Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 615864 - Upgrade stable dev-lang/perl-5.22.3_rc4 to stable 5.24.1-r1: conflicts
Summary: Upgrade stable dev-lang/perl-5.22.3_rc4 to stable 5.24.1-r1: conflicts
Status: UNCONFIRMED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Dependencies (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2017-04-17 16:08 UTC by Dmitry Grigoriev
Modified: 2017-04-25 20:40 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
output of `emerge -pvuND @world` (emerge-pvuND-world.perl-5.24.1-r1.log,27.52 KB, text/x-log)
2017-04-17 16:08 UTC, Dmitry Grigoriev
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Dmitry Grigoriev 2017-04-17 16:08:10 UTC
Created attachment 470278 [details]
output of `emerge -pvuND @world`

Since the moment dev-lang/perl-5.24.1-r1 gone stable, I get this (see full log in attachment, it's too large). How it can be fixed / worked around? Masking new perl, running perl-cleaner didn't help. Maybe uninstalling/reinstalling perl is OK? I'm just afraid to do it - wouldn't that render my system inoperable? Thanks.

# emerge -pvuND @world

These are the packages that would be merged, in order:

Calculating dependencies... done!
...
[ebuild     U  ] dev-lang/perl-5.24.1-r1:0/5.24::gentoo [5.22.3_rc4:0/5.22::gentoo] USE="gdbm -berkdb -debug -doc -ithreads" 11414 KiB
[ebuild     U  ] virtual/perl-Test-Harness-3.360.100_rc::gentoo [3.350.100_rc::gentoo] 0 KiB
...
[ebuild     U  ] virtual/perl-CPAN-Meta-2.150.5-r1::gentoo [2.150.1-r1::gentoo] 0 KiB
[ebuild     U ~] dev-qt/qt-creator-4.3.0_beta1::gentoo [4.2.0::gentoo] USE="android git valgrind webengine -autotools -baremetal -bazaar -clangcodemodel -clangstaticanalyzer -clearcase -cmake -cvs -designer% -doc -glsl -ios -mercurial -modeling -nim -perforce -python -qbs -qnx -scxml -subversion (-systemd) {-test} -winrt" LINGUAS="ru -cs -de -fr -ja -pl -sl -uk -zh_CN -zh_TW" 15957 KiB                                  
[ebuild     U  ] virtual/perl-Encode-2.800.100_rc::gentoo [2.730.0-r1::gentoo] 0 KiB
[uninstall     ] perl-core/Encode-2.730.0::gentoo 
[blocks b      ] <perl-core/Encode-2.800.100_rc ("<perl-core/Encode-2.800.100_rc" is blocking virtual/perl-Encode-2.800.100_rc)

Total: 26 packages (26 upgrades, 1 uninstall), Size of downloads: 27371 KiB
Conflict: 1 block

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-lang/perl:0

  (dev-lang/perl-5.24.1-r1:0/5.24::gentoo, ebuild scheduled for merge) pulled in by
    =dev-lang/perl-5.24* required by (virtual/perl-Perl-OSType-1.9.0-r1:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^  
...                                                                                                                                             
    =dev-lang/perl-5.24.1* required by (virtual/perl-libnet-3.80.100_rc:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^^^                                                                                                                                             

  (dev-lang/perl-5.22.3_rc4:0/5.22::gentoo, installed) pulled in by
    dev-lang/perl:0/5.22=[-build(-)] required by (dev-perl/IO-HTML-1.1.0:0/0::gentoo, installed)
                 ^^^^^^^^                                                                                                           
    dev-lang/perl:0/5.22=[-build(-)] required by (dev-perl/File-Listing-6.40.0-r1:0/0::gentoo, installed)
                 ^^^^^^^^                                                       
...                                                             
    dev-lang/perl:0/5.22=[-build(-)] required by (dev-perl/TermReadKey-2.330.0:0/0::gentoo, installed)
                 ^^^^^^^^
Comment 1 Dmitry Grigoriev 2017-04-17 16:08:36 UTC
# emerge --info
Portage 2.3.3 (python 3.4.5-final-0, default/linux/amd64/13.0/selinux, gcc-5.4.0, glibc-2.23-r3, 4.9.16-gentoo x86_64)
=================================================================
System uname: Linux-4.9.16-gentoo-x86_64-Intel-R-_Core-TM-_i7-3630QM_CPU_@_2.40GHz-with-gentoo-2.3
KiB Mem:    16317964 total,   1663880 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Mon, 17 Apr 2017 14:42:26 +0000
sh bash 4.3_p48-r1
ld GNU ld (Gentoo 2.26.1 p1.0) 2.26.1
ccache version 3.3.4 [enabled]
app-shells/bash:          4.3_p48-r1::gentoo
dev-java/java-config:     2.2.0-r3::gentoo
dev-lang/perl:            5.22.3_rc4::gentoo
dev-lang/python:          2.7.12::gentoo, 3.4.5::gentoo
dev-util/ccache:          3.3.4::gentoo
dev-util/cmake:           3.7.2::gentoo
dev-util/pkgconfig:       0.28-r2::gentoo
sys-apps/baselayout:      2.3::gentoo
sys-apps/openrc:          0.24.2::gentoo
sys-apps/sandbox:         2.10-r3::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69::gentoo
sys-devel/automake:       1.11.6-r1::gentoo, 1.12.6::gentoo, 1.15::gentoo
sys-devel/binutils:       2.26.1::gentoo
sys-devel/gcc:            5.4.0-r3::gentoo
sys-devel/gcc-config:     1.7.3::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1::gentoo
sys-kernel/linux-headers: 4.4::gentoo (virtual/os-headers)
sys-libs/glibc:           2.23-r3::gentoo
Repositories:

gentoo
    location: /usr/portage-git
    sync-type: rsync
    sync-uri: rsync://rsync.europe.gentoo.org/gentoo-portage
    priority: -1000

science
    location: /var/lib/layman/science
    masters: gentoo
    priority: 50

sft
    location: /var/lib/layman/sft
    masters: gentoo
    priority: 50

steam-overlay
    location: /var/lib/layman/steam-overlay
    masters: gentoo
    priority: 50

dimgel-local
    location: /usr/local/portage
    masters: gentoo
    priority: 999

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/gnupg/qualified.txt /usr/share/maven-bin-3.3/conf /var/bind"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -O2 -pipe"
DISTDIR="/usr/portage-distfiles"
EMERGE_DEFAULT_OPTS="--color=y --with-bdeps=y --verbose-conflicts --autounmask-keep-masks"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs ccache config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox selinux sesandbox sfperms splitdebug strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.yandex.ru/gentoo-distfiles/ http://gentoo-mirror.spb.ru/ "
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j6"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi alsa amd64 bash-completion bluetooth branding bzip2 cairo cdda cdr cli consolekit cracklib crypt cups cxx dbus dri dri2 dts dvd dvdr emboss encode eselect exif fam firefox flac fortran gdbm gif glamor gpm hal iconv ipv6 jpeg lash lcms libnotify mad mng modules mp3 mp4 mpeg multilib ncurses nls nptl ogg open_perms opengl openmp pam pango pcre pdf png policykit ppds qt5 readline scanner sdl seccomp selinux session spell ssl startup-notification svg tcpd tiff truetype udev udisks unconfined unicode upower usb vim-syntax vorbis wayland wxwidgets x264 xattr xcb xcomposite xinerama xml xorg xv xvid xvmc zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias proxy proxy_ajp proxy_http" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev synaptics" KERNEL="linux" L10N="en en-GB en-US ru" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en en-GB en-US ru" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_4" RUBY_TARGETS="ruby21 ruby22" USERLAND="GNU" VIDEO_CARDS="nvidia intel i915 i965 modesetting" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 2 Andreas K. Hüttel gentoo-dev 2017-04-17 16:24:51 UTC
Please try again with added emerge option "--backtrack 100"
Comment 3 Dmitry Grigoriev 2017-04-17 17:03:59 UTC
That worked. Thank you!
Comment 4 Michal Špondr 2017-04-18 21:02:59 UTC
(In reply to Andreas K. Hüttel from comment #2)
> Please try again with added emerge option "--backtrack 100"

I had the similar problem:

dev-lang/perl:0

  (dev-lang/perl-5.24.1-r1:0/5.24::gentoo, ebuild scheduled for merge) pulled in by
    =dev-lang/perl-5.24* required by (virtual/perl-Digest-MD5-2.540.0-r2:0/0::gentoo, installed)
    ^              ^^^^^                                                                                                                               
    (and 19 more with the same problem)

  (dev-lang/perl-5.22.3_rc4:0/5.22::gentoo, installed) pulled in by
    dev-lang/perl:0/5.22=[-build(-)] required by (dev-perl/HTTP-Negotiate-6.10.0:0/0::gentoo, installed)
                 ^^^^^^^^                                                                                                                   
    (and 54 more with the same problem)


--backtrack=30 helped as well, thanks.
Comment 5 Alex 2017-04-22 15:54:23 UTC
Similar issue here.
Upgrading to dev-lang/perl-5.24.1-r1 with "--backtrack=100" helped, with 17 upgrades and 30 rebuilds.
Comment 6 Simon 2017-04-23 18:55:39 UTC
Seems I had had the same happen during an automated build starting with a clean gentoo container. 

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:
dev-lang/perl:0
  (dev-lang/perl-5.22.3_rc4:0/5.22::gentoo, installed) pulled in by
    =dev-lang/perl-5.22* required by (virtual/perl-Data-Dumper-2.158.0-r1:0/0::gentoo, installed)
    ^              ^^^^^                                                                                                                                
    dev-lang/perl:0/5.22= required by (virtual/perl-File-Temp-0.230.400-r5:0/0::gentoo, installed)
                 ^^^^^^^^                                                                                                             
    (and 14 more with the same problems)
  (dev-lang/perl-5.24.1-r1:0/5.24::gentoo, ebuild scheduled for merge) pulled in by
    =dev-lang/perl-5.24* required by (virtual/perl-Scalar-List-Utils-1.420.200_rc-r1:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                                            
    (and 4 more with the same problem)

See https://travis-ci.org/simonvanderveldt/simonvanderveldt-overlay/builds/224929151 for the full log

Is the only way to fix this to increase the backtrack option?
Why is this necessary? Can't portage just be deterministic and figure it out?
Comment 7 Michael Palimaka (kensington) gentoo-dev 2017-04-25 07:37:19 UTC
Since this was worked around with increasing the backtrack value, passing to the portage team. There's probably existing bug(s) to track improvement of this behaviour, but they will be able to triage much better than I could.
Comment 8 Alexander Veit 2017-04-25 18:49:12 UTC
Similar problem here. It doesn't seem that Perl 5.24.1-r1 could be installed in a clean way.

emerge -au --backtrack=100 --verbose-conflicts @world

 * IMPORTANT: 1 news items need reading for repository 'gentoo'.
 * Use eselect news read to view new items.


These are the packages that would be merged, in order:

Calculating dependencies ... done!
[ebuild     U ~] dev-lang/perl-5.22.3 [5.22.3_rc4]

WARNING: One or more updates/rebuilds have been skipped due to a dependency conflict:

dev-lang/perl:0

  (dev-lang/perl-5.24.1-r1:0/5.24::gentoo, ebuild scheduled for merge) conflicts with
    =dev-lang/perl-5.22* required by (virtual/perl-Getopt-Long-2.450.0-r1:0/0::gentoo, installed)
    ^              ^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-ExtUtils-Install-2.40.0-r2:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-ExtUtils-Manifest-1.700.0-r3:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-MIME-Base64-3.150.0-r2:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-Exporter-5.720.0-r2:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-Digest-SHA-5.950.100_rc-r1:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-Digest-MD5-2.540.0-r2:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-Archive-Tar-2.40.100_rc-r1:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-JSON-PP-2.273.0.100_rc-r1:0/0::gentoo, installed)
                 ^^^^^^^^
    dev-lang/perl:0/5.22= required by (virtual/perl-Getopt-Long-2.450.0-r1:0/0::gentoo, installed)
                 ^^^^^^^^


!!! The following update(s) have been skipped due to unsatisfied dependencies
!!! triggered by backtracking:

virtual/perl-CPAN-Meta-YAML:0
virtual/perl-version:0
virtual/perl-Test-Harness:0
virtual/perl-Scalar-List-Utils:0
virtual/perl-ExtUtils-ParseXS:0
virtual/perl-parent:0
virtual/perl-File-Spec:0
virtual/perl-Perl-OSType:0
virtual/perl-Data-Dumper:0
virtual/perl-libnet:0
virtual/perl-Parse-CPAN-Meta:0
virtual/perl-Module-Metadata:0
virtual/perl-ExtUtils-CBuilder:0
virtual/perl-CPAN-Meta:0
virtual/perl-ExtUtils-MakeMaker:0

The following keyword changes are necessary to proceed:
 (see "package.accept_keywords" in the portage(5) man page for more details)
# required by virtual/perl-Test-Simple-1.1.14_p522-r1::gentoo
# required by @selected
# required by @world (argument)
=dev-lang/perl-5.22.3 ~amd64
Comment 9 Zac Medico gentoo-dev 2017-04-25 20:40:31 UTC
For conflicts involving built slot operator (foo/bar:X/Y=) dependencies, you should follow the suggestions here:

https://wiki.gentoo.org/wiki/Project:Portage/FAQ#What_should_I_do_when_emerge_reports_a_lot_of_dependency_conflicts_involving_built_slot-operator_.28foo.2Fbar:X.2FY.3D.29_dependencies.3F

I use --ask rather than --pretend, so that emerge will prompt me when it has configuration changes to write.